/* taquin-view.c generated by valac 0.56.18, the Vala compiler
 * generated from taquin-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Taquin.

   Copyright (C) 2014-2016 – Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME Taquin is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Taquin is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Taquin.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define TAQUIN_VIEW_GRID_SPACING 1
#define TAQUIN_VIEW_half_pi (G_PI / 2.0)
#define TAQUIN_VIEW_three_half_pi (TAQUIN_VIEW_half_pi * 3.0)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DIRECTION_TOP,
	DIRECTION_LEFT,
	DIRECTION_RIGHT,
	DIRECTION_BOTTOM,
	DIRECTION_NONE
} Direction;

#define TYPE_DIRECTION (direction_get_type ())

#define TYPE_TAQUIN_VIEW (taquin_view_get_type ())
#define TAQUIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAQUIN_VIEW, TaquinView))
#define TAQUIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAQUIN_VIEW, TaquinViewClass))
#define IS_TAQUIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAQUIN_VIEW))
#define IS_TAQUIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAQUIN_VIEW))
#define TAQUIN_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAQUIN_VIEW, TaquinViewClass))

typedef struct _TaquinView TaquinView;
typedef struct _TaquinViewClass TaquinViewClass;
typedef struct _TaquinViewPrivate TaquinViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
enum  {
	TAQUIN_VIEW_0_PROPERTY,
	TAQUIN_VIEW_GAME_PROPERTY,
	TAQUIN_VIEW_THEME_PROPERTY,
	TAQUIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* taquin_view_properties[TAQUIN_VIEW_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef enum  {
	GAME_TYPE_FIFTEEN,
	GAME_TYPE_SIXTEEN
} GameType;

#define TYPE_GAME_TYPE (game_type_get_type ())

struct _TaquinView {
	GtkDrawingArea parent_instance;
	TaquinViewPrivate * priv;
};

struct _TaquinViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _TaquinViewPrivate {
	gint grid_border_main;
	gint grid_border_thin;
	gint arrows;
	gint tile_size;
	gint board_size;
	gint8 x_arrow;
	gint8 y_arrow;
	gboolean draw_lights;
	gint render_size;
	cairo_pattern_t* tiles_pattern;
	gboolean animate;
	gint animation_offset;
	gboolean x_axis;
	gint number;
	gint8 x_gap;
	gint8 y_gap;
	gboolean animate_end;
	gboolean finished;
	gdouble animation_end_offset;
	Game* _game;
	GdkPixbuf* unscaled_pixbuf;
	gchar* _theme;
	GtkGestureMultiPress* click_controller;
	GtkEventControllerKey* key_controller;
};

static gint TaquinView_private_offset;
static gpointer taquin_view_parent_class = NULL;

VALA_EXTERN GType direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType taquin_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TaquinView, g_object_unref)
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN TaquinView* taquin_view_new (void);
VALA_EXTERN TaquinView* taquin_view_construct (GType object_type);
static gboolean taquin_view_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* e);
static void taquin_view_configure (TaquinView* self);
static Game* taquin_view_get_game (TaquinView* self);
VALA_EXTERN gint8 game_get_size (Game* self);
static gboolean taquin_view_real_draw (GtkWidget* base,
                                cairo_t* cr);
static inline void _taquin_view_refresh_pixmaps (cairo_t* context,
                                   GdkPixbuf* unscaled_pixbuf,
                                   gint* board_size);
static gint taquin_view_get_x_offset (TaquinView* self);
static gint taquin_view_get_y_offset (TaquinView* self);
static inline void _taquin_view_draw_board (cairo_t* cr,
                              gint* grid_border_main,
                              gint* board_size,
                              gint* grid_border_thin);
VALA_EXTERN GType game_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameType game_get_game_type (Game* self);
static inline void taquin_view_draw_movable_lights (TaquinView* self,
                                      cairo_t* cr);
static inline void taquin_view_draw_fixed_arrows (TaquinView* self,
                                    cairo_t* cr);
static inline void taquin_view_draw_movable_arrows (TaquinView* self,
                                      cairo_t* cr);
VALA_EXTERN gint8 game_get_tile_value (Game* self,
                           gint8 x,
                           gint8 y);
static inline void _taquin_view_draw_movable_lights (cairo_t* cr,
                                       gdouble* animation_end_offset,
                                       gint* grid_border_main,
                                       gint* tile_size,
                                       gint8* x_arrow,
                                       gint* grid_border_thin,
                                       gint* board_size,
                                       gint8* y_arrow);
static void taquin_view_draw_light (cairo_t* cr,
                             gboolean horizontal,
                             gint* tile_size,
                             gint* grid_border_main);
static inline void _taquin_view_draw_fixed_arrows (cairo_t* cr,
                                     gint game_size,
                                     gint* grid_border_main,
                                     gint* tile_size,
                                     gint* grid_border_thin,
                                     gint* board_size);
static void taquin_view_draw_vertical_arrow (cairo_t* cr,
                                      gboolean inside,
                                      gint number,
                                      gint* grid_border_main,
                                      gint* tile_size,
                                      gint* grid_border_thin,
                                      gint* board_size);
static void taquin_view_draw_horizontal_arrow (cairo_t* cr,
                                        gboolean inside,
                                        gint number,
                                        gint* grid_border_main,
                                        gint* tile_size,
                                        gint* grid_border_thin,
                                        gint* board_size);
static inline void _taquin_view_draw_movable_arrows (cairo_t* cr,
                                       gint8* x_arrow,
                                       gint8* y_arrow,
                                       gint* grid_border_main,
                                       gint* tile_size,
                                       gint* grid_border_thin,
                                       gint* board_size);
static void taquin_view_move_cb (TaquinView* self,
                          gboolean x_axis,
                          gint8 number,
                          gint8 x_gap,
                          gint8 y_gap,
                          guint moves_count,
                          gboolean disable_animation);
static void taquin_view_complete_cb (TaquinView* self);
static gboolean __lambda13_ (TaquinView* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static void taquin_view_init_mouse (TaquinView* self);
static inline void taquin_view_on_click (TaquinView* self,
                           GtkGestureMultiPress* _click_controller,
                           gint n_press,
                           gdouble event_x,
                           gdouble event_y);
static void _taquin_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self);
VALA_EXTERN void game_request_move (Game* self,
                        gint8 x,
                        gint8 y,
                        gboolean keyboard_call);
static void taquin_view_init_keyboard (TaquinView* self);
static inline gboolean taquin_view_on_key_pressed (TaquinView* self,
                                     GtkEventControllerKey* _key_controller,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _taquin_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
VALA_EXTERN void taquin_view_set_game (TaquinView* self,
                           Game* value);
static void _taquin_view_move_cb_game_move (Game* _sender,
                                     gboolean x_axis,
                                     gint8 number,
                                     gint8 x_gap,
                                     gint8 y_gap,
                                     guint moves_count,
                                     gboolean disable_animation,
                                     gpointer self);
static void _taquin_view_complete_cb_game_complete (Game* _sender,
                                             gpointer self);
static const gchar* taquin_view_get_theme (TaquinView* self);
VALA_EXTERN void taquin_view_set_theme (TaquinView* self,
                            const gchar* value);
static GObject * taquin_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void taquin_view_finalize (GObject * obj);
static GType taquin_view_get_type_once (void);
static void _vala_taquin_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_taquin_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
direction_get_type_once (void)
{
	static const GEnumValue values[] = {{DIRECTION_TOP, "DIRECTION_TOP", "top"}, {DIRECTION_LEFT, "DIRECTION_LEFT", "left"}, {DIRECTION_RIGHT, "DIRECTION_RIGHT", "right"}, {DIRECTION_BOTTOM, "DIRECTION_BOTTOM", "bottom"}, {DIRECTION_NONE, "DIRECTION_NONE", "none"}, {0, NULL, NULL}};
	GType direction_type_id;
	direction_type_id = g_enum_register_static ("Direction", values);
	return direction_type_id;
}

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__once = 0;
	if (g_once_init_enter (&direction_type_id__once)) {
		GType direction_type_id;
		direction_type_id = direction_get_type_once ();
		g_once_init_leave (&direction_type_id__once, direction_type_id);
	}
	return direction_type_id__once;
}

static inline gpointer
taquin_view_get_instance_private (TaquinView* self)
{
	return G_STRUCT_MEMBER_P (self, TaquinView_private_offset);
}

TaquinView*
taquin_view_construct (GType object_type)
{
	TaquinView * self = NULL;
#line 72 "../src/taquin-view.vala"
	self = (TaquinView*) g_object_new (object_type, NULL);
#line 74 "../src/taquin-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 75 "../src/taquin-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK));
#line 72 "../src/taquin-view.vala"
	return self;
#line 324 "taquin-view.c"
}

TaquinView*
taquin_view_new (void)
{
#line 72 "../src/taquin-view.vala"
	return taquin_view_construct (TYPE_TAQUIN_VIEW);
#line 332 "taquin-view.c"
}

static gboolean
taquin_view_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* e)
{
	TaquinView * self;
	gboolean result;
#line 123 "../src/taquin-view.vala"
	self = (TaquinView*) base;
#line 123 "../src/taquin-view.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 125 "../src/taquin-view.vala"
	taquin_view_configure (self);
#line 126 "../src/taquin-view.vala"
	result = TRUE;
#line 126 "../src/taquin-view.vala"
	return result;
#line 351 "taquin-view.c"
}

static void
taquin_view_configure (TaquinView* self)
{
	gint size = 0;
	Game* _tmp0_;
	Game* _tmp1_;
	gint8 _tmp2_;
	gint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	gint8 _tmp6_;
	gint8 _tmp7_;
#line 129 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/taquin-view.vala"
	size = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 133 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 133 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 133 "../src/taquin-view.vala"
	_tmp2_ = game_get_size (_tmp1_);
#line 133 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 133 "../src/taquin-view.vala"
	self->priv->tile_size = ((size * 10) / 12) / _tmp3_;
#line 134 "../src/taquin-view.vala"
	_tmp4_ = taquin_view_get_game (self);
#line 134 "../src/taquin-view.vala"
	_tmp5_ = _tmp4_;
#line 134 "../src/taquin-view.vala"
	_tmp6_ = game_get_size (_tmp5_);
#line 134 "../src/taquin-view.vala"
	_tmp7_ = _tmp6_;
#line 134 "../src/taquin-view.vala"
	self->priv->board_size = (self->priv->tile_size * _tmp7_) - TAQUIN_VIEW_GRID_SPACING;
#line 135 "../src/taquin-view.vala"
	self->priv->grid_border_main = (size - self->priv->board_size) / 2;
#line 136 "../src/taquin-view.vala"
	self->priv->arrows = size / 100;
#line 394 "taquin-view.c"
}

static gboolean
taquin_view_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	TaquinView * self;
	gboolean _tmp0_ = FALSE;
	cairo_pattern_t* _tmp1_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	Game* _tmp14_;
	Game* _tmp15_;
	GameType _tmp16_;
	GameType _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean result;
#line 139 "../src/taquin-view.vala"
	self = (TaquinView*) base;
#line 139 "../src/taquin-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 141 "../src/taquin-view.vala"
	_tmp1_ = self->priv->tiles_pattern;
#line 141 "../src/taquin-view.vala"
	if (_tmp1_ == NULL) {
#line 141 "../src/taquin-view.vala"
		_tmp0_ = TRUE;
#line 424 "taquin-view.c"
	} else {
#line 141 "../src/taquin-view.vala"
		_tmp0_ = self->priv->render_size != self->priv->tile_size;
#line 428 "taquin-view.c"
	}
#line 141 "../src/taquin-view.vala"
	if (_tmp0_) {
#line 432 "taquin-view.c"
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp4_;
		cairo_t* _tmp5_;
		cairo_t* _tmp6_;
		GdkPixbuf* _tmp7_;
		cairo_surface_t* _tmp8_;
		cairo_pattern_t* _tmp9_;
#line 143 "../src/taquin-view.vala"
		self->priv->render_size = self->priv->tile_size;
#line 144 "../src/taquin-view.vala"
		_tmp2_ = cairo_get_target (cr);
#line 144 "../src/taquin-view.vala"
		_tmp3_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
#line 144 "../src/taquin-view.vala"
		surface = _tmp3_;
#line 145 "../src/taquin-view.vala"
		_tmp4_ = surface;
#line 145 "../src/taquin-view.vala"
		_tmp5_ = cairo_create (_tmp4_);
#line 145 "../src/taquin-view.vala"
		c = _tmp5_;
#line 146 "../src/taquin-view.vala"
		_tmp6_ = c;
#line 146 "../src/taquin-view.vala"
		_tmp7_ = self->priv->unscaled_pixbuf;
#line 146 "../src/taquin-view.vala"
		_taquin_view_refresh_pixmaps (_tmp6_, _tmp7_, &self->priv->board_size);
#line 147 "../src/taquin-view.vala"
		_tmp8_ = surface;
#line 147 "../src/taquin-view.vala"
		_tmp9_ = cairo_pattern_create_for_surface (_tmp8_);
#line 147 "../src/taquin-view.vala"
		_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 147 "../src/taquin-view.vala"
		self->priv->tiles_pattern = _tmp9_;
#line 141 "../src/taquin-view.vala"
		_cairo_destroy0 (c);
#line 141 "../src/taquin-view.vala"
		_cairo_surface_destroy0 (surface);
#line 475 "taquin-view.c"
	}
#line 150 "../src/taquin-view.vala"
	_tmp10_ = taquin_view_get_x_offset (self);
#line 150 "../src/taquin-view.vala"
	_tmp11_ = _tmp10_;
#line 150 "../src/taquin-view.vala"
	_tmp12_ = taquin_view_get_y_offset (self);
#line 150 "../src/taquin-view.vala"
	_tmp13_ = _tmp12_;
#line 150 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) _tmp11_, (gdouble) _tmp13_);
#line 151 "../src/taquin-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 152 "../src/taquin-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 154 "../src/taquin-view.vala"
	_taquin_view_draw_board (cr, &self->priv->grid_border_main, &self->priv->board_size, &self->priv->grid_border_thin);
#line 157 "../src/taquin-view.vala"
	cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1.0 - self->priv->animation_end_offset);
#line 158 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->arrows);
#line 159 "../src/taquin-view.vala"
	_tmp14_ = taquin_view_get_game (self);
#line 159 "../src/taquin-view.vala"
	_tmp15_ = _tmp14_;
#line 159 "../src/taquin-view.vala"
	_tmp16_ = game_get_game_type (_tmp15_);
#line 159 "../src/taquin-view.vala"
	_tmp17_ = _tmp16_;
#line 159 "../src/taquin-view.vala"
	if (_tmp17_ == GAME_TYPE_SIXTEEN) {
#line 161 "../src/taquin-view.vala"
		if (self->priv->draw_lights) {
#line 162 "../src/taquin-view.vala"
			taquin_view_draw_movable_lights (self, cr);
#line 511 "taquin-view.c"
		}
#line 163 "../src/taquin-view.vala"
		taquin_view_draw_fixed_arrows (self, cr);
#line 515 "taquin-view.c"
	} else {
#line 166 "../src/taquin-view.vala"
		taquin_view_draw_movable_arrows (self, cr);
#line 519 "taquin-view.c"
	}
#line 167 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 170 "../src/taquin-view.vala"
	cairo_save (cr);
#line 171 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) self->priv->grid_border_main, (gdouble) self->priv->grid_border_main);
#line 173 "../src/taquin-view.vala"
	if (self->priv->animate) {
#line 529 "taquin-view.c"
		Game* _tmp19_;
		Game* _tmp20_;
		GameType _tmp21_;
		GameType _tmp22_;
#line 173 "../src/taquin-view.vala"
		_tmp19_ = taquin_view_get_game (self);
#line 173 "../src/taquin-view.vala"
		_tmp20_ = _tmp19_;
#line 173 "../src/taquin-view.vala"
		_tmp21_ = game_get_game_type (_tmp20_);
#line 173 "../src/taquin-view.vala"
		_tmp22_ = _tmp21_;
#line 173 "../src/taquin-view.vala"
		_tmp18_ = _tmp22_ == GAME_TYPE_SIXTEEN;
#line 544 "taquin-view.c"
	} else {
#line 173 "../src/taquin-view.vala"
		_tmp18_ = FALSE;
#line 548 "taquin-view.c"
	}
#line 173 "../src/taquin-view.vala"
	if (_tmp18_) {
#line 552 "taquin-view.c"
		gint texture_x = 0;
		Game* _tmp23_;
		Game* _tmp24_;
		Game* _tmp25_;
		Game* _tmp26_;
		gint8 _tmp27_;
		gint8 _tmp28_;
		gint texture_y = 0;
		Game* _tmp29_;
		Game* _tmp30_;
		Game* _tmp31_;
		Game* _tmp32_;
		gint8 _tmp33_;
		gint8 _tmp34_;
		gint tile_x = 0;
		gint tile_y = 0;
		cairo_matrix_t matrix = {0};
		cairo_pattern_t* _tmp35_;
		cairo_matrix_t _tmp36_;
		cairo_pattern_t* _tmp37_;
		gint _tmp38_ = 0;
		gint8 _tmp44_ = 0;
		cairo_pattern_t* _tmp50_;
		cairo_matrix_t _tmp51_;
		cairo_pattern_t* _tmp52_;
#line 175 "../src/taquin-view.vala"
		_tmp23_ = taquin_view_get_game (self);
#line 175 "../src/taquin-view.vala"
		_tmp24_ = _tmp23_;
#line 175 "../src/taquin-view.vala"
		_tmp25_ = taquin_view_get_game (self);
#line 175 "../src/taquin-view.vala"
		_tmp26_ = _tmp25_;
#line 175 "../src/taquin-view.vala"
		_tmp27_ = game_get_size (_tmp26_);
#line 175 "../src/taquin-view.vala"
		_tmp28_ = _tmp27_;
#line 175 "../src/taquin-view.vala"
		texture_x = (game_get_tile_value (_tmp24_, self->priv->x_gap, self->priv->y_gap) % _tmp28_) * self->priv->tile_size;
#line 176 "../src/taquin-view.vala"
		_tmp29_ = taquin_view_get_game (self);
#line 176 "../src/taquin-view.vala"
		_tmp30_ = _tmp29_;
#line 176 "../src/taquin-view.vala"
		_tmp31_ = taquin_view_get_game (self);
#line 176 "../src/taquin-view.vala"
		_tmp32_ = _tmp31_;
#line 176 "../src/taquin-view.vala"
		_tmp33_ = game_get_size (_tmp32_);
#line 176 "../src/taquin-view.vala"
		_tmp34_ = _tmp33_;
#line 176 "../src/taquin-view.vala"
		texture_y = (game_get_tile_value (_tmp30_, self->priv->x_gap, self->priv->y_gap) / _tmp34_) * self->priv->tile_size;
#line 179 "../src/taquin-view.vala"
		tile_x = self->priv->x_gap * self->priv->tile_size;
#line 180 "../src/taquin-view.vala"
		tile_y = self->priv->y_gap * self->priv->tile_size;
#line 182 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 183 "../src/taquin-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 184 "../src/taquin-view.vala"
		_tmp35_ = self->priv->tiles_pattern;
#line 184 "../src/taquin-view.vala"
		_tmp36_ = matrix;
#line 184 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp35_, &_tmp36_);
#line 185 "../src/taquin-view.vala"
		_tmp37_ = self->priv->tiles_pattern;
#line 185 "../src/taquin-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) _tmp37_);
#line 186 "../src/taquin-view.vala"
		cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 187 "../src/taquin-view.vala"
		cairo_fill (cr);
#line 190 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 630 "taquin-view.c"
			gint _tmp39_ = 0;
#line 190 "../src/taquin-view.vala"
			if (((gint) self->priv->x_gap) == 0) {
#line 634 "taquin-view.c"
				Game* _tmp40_;
				Game* _tmp41_;
				gint8 _tmp42_;
				gint8 _tmp43_;
#line 190 "../src/taquin-view.vala"
				_tmp40_ = taquin_view_get_game (self);
#line 190 "../src/taquin-view.vala"
				_tmp41_ = _tmp40_;
#line 190 "../src/taquin-view.vala"
				_tmp42_ = game_get_size (_tmp41_);
#line 190 "../src/taquin-view.vala"
				_tmp43_ = _tmp42_;
#line 190 "../src/taquin-view.vala"
				_tmp39_ = _tmp43_ - 1;
#line 649 "taquin-view.c"
			} else {
#line 190 "../src/taquin-view.vala"
				_tmp39_ = 0;
#line 653 "taquin-view.c"
			}
#line 190 "../src/taquin-view.vala"
			_tmp38_ = _tmp39_;
#line 657 "taquin-view.c"
		} else {
#line 190 "../src/taquin-view.vala"
			_tmp38_ = (gint) self->priv->x_gap;
#line 661 "taquin-view.c"
		}
#line 190 "../src/taquin-view.vala"
		tile_x = self->priv->tile_size * _tmp38_;
#line 191 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 191 "../src/taquin-view.vala"
			_tmp44_ = self->priv->y_gap;
#line 669 "taquin-view.c"
		} else {
			gint _tmp45_ = 0;
#line 191 "../src/taquin-view.vala"
			if (((gint) self->priv->y_gap) == 0) {
#line 674 "taquin-view.c"
				Game* _tmp46_;
				Game* _tmp47_;
				gint8 _tmp48_;
				gint8 _tmp49_;
#line 191 "../src/taquin-view.vala"
				_tmp46_ = taquin_view_get_game (self);
#line 191 "../src/taquin-view.vala"
				_tmp47_ = _tmp46_;
#line 191 "../src/taquin-view.vala"
				_tmp48_ = game_get_size (_tmp47_);
#line 191 "../src/taquin-view.vala"
				_tmp49_ = _tmp48_;
#line 191 "../src/taquin-view.vala"
				_tmp45_ = _tmp49_ - 1;
#line 689 "taquin-view.c"
			} else {
#line 191 "../src/taquin-view.vala"
				_tmp45_ = 0;
#line 693 "taquin-view.c"
			}
#line 191 "../src/taquin-view.vala"
			_tmp44_ = (gint8) _tmp45_;
#line 697 "taquin-view.c"
		}
#line 191 "../src/taquin-view.vala"
		tile_y = self->priv->tile_size * _tmp44_;
#line 193 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 194 "../src/taquin-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 195 "../src/taquin-view.vala"
		_tmp50_ = self->priv->tiles_pattern;
#line 195 "../src/taquin-view.vala"
		_tmp51_ = matrix;
#line 195 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp50_, &_tmp51_);
#line 196 "../src/taquin-view.vala"
		_tmp52_ = self->priv->tiles_pattern;
#line 196 "../src/taquin-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) _tmp52_);
#line 197 "../src/taquin-view.vala"
		cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 198 "../src/taquin-view.vala"
		cairo_fill (cr);
#line 719 "taquin-view.c"
	}
	{
		gint y = 0;
#line 201 "../src/taquin-view.vala"
		y = 0;
#line 725 "taquin-view.c"
		{
			gboolean _tmp53_ = FALSE;
#line 201 "../src/taquin-view.vala"
			_tmp53_ = TRUE;
#line 201 "../src/taquin-view.vala"
			while (TRUE) {
#line 732 "taquin-view.c"
				Game* _tmp55_;
				Game* _tmp56_;
				gint8 _tmp57_;
				gint8 _tmp58_;
#line 201 "../src/taquin-view.vala"
				if (!_tmp53_) {
#line 739 "taquin-view.c"
					gint _tmp54_;
#line 201 "../src/taquin-view.vala"
					_tmp54_ = y;
#line 201 "../src/taquin-view.vala"
					y = _tmp54_ + 1;
#line 745 "taquin-view.c"
				}
#line 201 "../src/taquin-view.vala"
				_tmp53_ = FALSE;
#line 201 "../src/taquin-view.vala"
				_tmp55_ = taquin_view_get_game (self);
#line 201 "../src/taquin-view.vala"
				_tmp56_ = _tmp55_;
#line 201 "../src/taquin-view.vala"
				_tmp57_ = game_get_size (_tmp56_);
#line 201 "../src/taquin-view.vala"
				_tmp58_ = _tmp57_;
#line 201 "../src/taquin-view.vala"
				if (!(y < ((gint) _tmp58_))) {
#line 201 "../src/taquin-view.vala"
					break;
#line 761 "taquin-view.c"
				}
				{
					gint x = 0;
#line 203 "../src/taquin-view.vala"
					x = 0;
#line 767 "taquin-view.c"
					{
						gboolean _tmp59_ = FALSE;
#line 203 "../src/taquin-view.vala"
						_tmp59_ = TRUE;
#line 203 "../src/taquin-view.vala"
						while (TRUE) {
#line 774 "taquin-view.c"
							Game* _tmp61_;
							Game* _tmp62_;
							gint8 _tmp63_;
							gint8 _tmp64_;
							gboolean _tmp65_ = FALSE;
							gboolean _tmp66_ = FALSE;
							gint tile_x = 0;
							gint tile_y = 0;
							gboolean _tmp67_ = FALSE;
							gint texture_x = 0;
							Game* _tmp79_;
							Game* _tmp80_;
							Game* _tmp81_;
							Game* _tmp82_;
							gint8 _tmp83_;
							gint8 _tmp84_;
							gint texture_y = 0;
							Game* _tmp85_;
							Game* _tmp86_;
							Game* _tmp87_;
							Game* _tmp88_;
							gint8 _tmp89_;
							gint8 _tmp90_;
							cairo_matrix_t matrix = {0};
							cairo_pattern_t* _tmp91_;
							cairo_matrix_t _tmp92_;
							cairo_pattern_t* _tmp93_;
#line 203 "../src/taquin-view.vala"
							if (!_tmp59_) {
#line 804 "taquin-view.c"
								gint _tmp60_;
#line 203 "../src/taquin-view.vala"
								_tmp60_ = x;
#line 203 "../src/taquin-view.vala"
								x = _tmp60_ + 1;
#line 810 "taquin-view.c"
							}
#line 203 "../src/taquin-view.vala"
							_tmp59_ = FALSE;
#line 203 "../src/taquin-view.vala"
							_tmp61_ = taquin_view_get_game (self);
#line 203 "../src/taquin-view.vala"
							_tmp62_ = _tmp61_;
#line 203 "../src/taquin-view.vala"
							_tmp63_ = game_get_size (_tmp62_);
#line 203 "../src/taquin-view.vala"
							_tmp64_ = _tmp63_;
#line 203 "../src/taquin-view.vala"
							if (!(x < ((gint) _tmp64_))) {
#line 203 "../src/taquin-view.vala"
								break;
#line 826 "taquin-view.c"
							}
#line 205 "../src/taquin-view.vala"
							if (self->priv->animate) {
#line 205 "../src/taquin-view.vala"
								_tmp66_ = x == ((gint) self->priv->x_gap);
#line 832 "taquin-view.c"
							} else {
#line 205 "../src/taquin-view.vala"
								_tmp66_ = FALSE;
#line 836 "taquin-view.c"
							}
#line 205 "../src/taquin-view.vala"
							if (_tmp66_) {
#line 205 "../src/taquin-view.vala"
								_tmp65_ = y == ((gint) self->priv->y_gap);
#line 842 "taquin-view.c"
							} else {
#line 205 "../src/taquin-view.vala"
								_tmp65_ = FALSE;
#line 846 "taquin-view.c"
							}
#line 205 "../src/taquin-view.vala"
							if (_tmp65_) {
#line 206 "../src/taquin-view.vala"
								continue;
#line 852 "taquin-view.c"
							}
#line 208 "../src/taquin-view.vala"
							tile_x = x * self->priv->tile_size;
#line 209 "../src/taquin-view.vala"
							tile_y = y * self->priv->tile_size;
#line 211 "../src/taquin-view.vala"
							if (self->priv->animate) {
#line 860 "taquin-view.c"
								gboolean _tmp68_ = FALSE;
#line 211 "../src/taquin-view.vala"
								if (x != ((gint) self->priv->x_gap)) {
#line 211 "../src/taquin-view.vala"
									_tmp68_ = TRUE;
#line 866 "taquin-view.c"
								} else {
#line 211 "../src/taquin-view.vala"
									_tmp68_ = y != ((gint) self->priv->y_gap);
#line 870 "taquin-view.c"
								}
#line 211 "../src/taquin-view.vala"
								_tmp67_ = _tmp68_;
#line 874 "taquin-view.c"
							} else {
#line 211 "../src/taquin-view.vala"
								_tmp67_ = FALSE;
#line 878 "taquin-view.c"
							}
#line 211 "../src/taquin-view.vala"
							if (_tmp67_) {
#line 882 "taquin-view.c"
								gboolean _tmp69_ = FALSE;
#line 213 "../src/taquin-view.vala"
								if (self->priv->x_axis) {
#line 213 "../src/taquin-view.vala"
									_tmp69_ = y == ((gint) self->priv->y_gap);
#line 888 "taquin-view.c"
								} else {
#line 213 "../src/taquin-view.vala"
									_tmp69_ = FALSE;
#line 892 "taquin-view.c"
								}
#line 213 "../src/taquin-view.vala"
								if (_tmp69_) {
#line 896 "taquin-view.c"
									gboolean _tmp70_ = FALSE;
									gboolean _tmp71_ = FALSE;
#line 215 "../src/taquin-view.vala"
									if (self->priv->number > 0) {
#line 215 "../src/taquin-view.vala"
										_tmp71_ = x <= (self->priv->x_gap + self->priv->number);
#line 903 "taquin-view.c"
									} else {
#line 215 "../src/taquin-view.vala"
										_tmp71_ = FALSE;
#line 907 "taquin-view.c"
									}
#line 215 "../src/taquin-view.vala"
									if (_tmp71_) {
#line 215 "../src/taquin-view.vala"
										_tmp70_ = x >= ((gint) self->priv->x_gap);
#line 913 "taquin-view.c"
									} else {
#line 215 "../src/taquin-view.vala"
										_tmp70_ = FALSE;
#line 917 "taquin-view.c"
									}
#line 215 "../src/taquin-view.vala"
									if (_tmp70_) {
#line 216 "../src/taquin-view.vala"
										tile_x -= self->priv->tile_size - self->priv->animation_offset;
#line 923 "taquin-view.c"
									} else {
										gboolean _tmp72_ = FALSE;
										gboolean _tmp73_ = FALSE;
#line 217 "../src/taquin-view.vala"
										if (self->priv->number < 0) {
#line 217 "../src/taquin-view.vala"
											_tmp73_ = x >= (self->priv->x_gap + self->priv->number);
#line 931 "taquin-view.c"
										} else {
#line 217 "../src/taquin-view.vala"
											_tmp73_ = FALSE;
#line 935 "taquin-view.c"
										}
#line 217 "../src/taquin-view.vala"
										if (_tmp73_) {
#line 217 "../src/taquin-view.vala"
											_tmp72_ = x <= ((gint) self->priv->x_gap);
#line 941 "taquin-view.c"
										} else {
#line 217 "../src/taquin-view.vala"
											_tmp72_ = FALSE;
#line 945 "taquin-view.c"
										}
#line 217 "../src/taquin-view.vala"
										if (_tmp72_) {
#line 218 "../src/taquin-view.vala"
											tile_x += self->priv->tile_size - self->priv->animation_offset;
#line 951 "taquin-view.c"
										}
									}
								} else {
									gboolean _tmp74_ = FALSE;
#line 220 "../src/taquin-view.vala"
									if (!self->priv->x_axis) {
#line 220 "../src/taquin-view.vala"
										_tmp74_ = x == ((gint) self->priv->x_gap);
#line 960 "taquin-view.c"
									} else {
#line 220 "../src/taquin-view.vala"
										_tmp74_ = FALSE;
#line 964 "taquin-view.c"
									}
#line 220 "../src/taquin-view.vala"
									if (_tmp74_) {
#line 968 "taquin-view.c"
										gboolean _tmp75_ = FALSE;
										gboolean _tmp76_ = FALSE;
#line 222 "../src/taquin-view.vala"
										if (self->priv->number > 0) {
#line 222 "../src/taquin-view.vala"
											_tmp76_ = y <= (self->priv->y_gap + self->priv->number);
#line 975 "taquin-view.c"
										} else {
#line 222 "../src/taquin-view.vala"
											_tmp76_ = FALSE;
#line 979 "taquin-view.c"
										}
#line 222 "../src/taquin-view.vala"
										if (_tmp76_) {
#line 222 "../src/taquin-view.vala"
											_tmp75_ = y >= ((gint) self->priv->y_gap);
#line 985 "taquin-view.c"
										} else {
#line 222 "../src/taquin-view.vala"
											_tmp75_ = FALSE;
#line 989 "taquin-view.c"
										}
#line 222 "../src/taquin-view.vala"
										if (_tmp75_) {
#line 223 "../src/taquin-view.vala"
											tile_y -= self->priv->tile_size - self->priv->animation_offset;
#line 995 "taquin-view.c"
										} else {
											gboolean _tmp77_ = FALSE;
											gboolean _tmp78_ = FALSE;
#line 224 "../src/taquin-view.vala"
											if (self->priv->number < 0) {
#line 224 "../src/taquin-view.vala"
												_tmp78_ = y >= (self->priv->y_gap + self->priv->number);
#line 1003 "taquin-view.c"
											} else {
#line 224 "../src/taquin-view.vala"
												_tmp78_ = FALSE;
#line 1007 "taquin-view.c"
											}
#line 224 "../src/taquin-view.vala"
											if (_tmp78_) {
#line 224 "../src/taquin-view.vala"
												_tmp77_ = y <= ((gint) self->priv->y_gap);
#line 1013 "taquin-view.c"
											} else {
#line 224 "../src/taquin-view.vala"
												_tmp77_ = FALSE;
#line 1017 "taquin-view.c"
											}
#line 224 "../src/taquin-view.vala"
											if (_tmp77_) {
#line 225 "../src/taquin-view.vala"
												tile_y += self->priv->tile_size - self->priv->animation_offset;
#line 1023 "taquin-view.c"
											}
										}
									}
								}
							}
#line 229 "../src/taquin-view.vala"
							_tmp79_ = taquin_view_get_game (self);
#line 229 "../src/taquin-view.vala"
							_tmp80_ = _tmp79_;
#line 229 "../src/taquin-view.vala"
							_tmp81_ = taquin_view_get_game (self);
#line 229 "../src/taquin-view.vala"
							_tmp82_ = _tmp81_;
#line 229 "../src/taquin-view.vala"
							_tmp83_ = game_get_size (_tmp82_);
#line 229 "../src/taquin-view.vala"
							_tmp84_ = _tmp83_;
#line 229 "../src/taquin-view.vala"
							texture_x = (game_get_tile_value (_tmp80_, (gint8) x, (gint8) y) % _tmp84_) * self->priv->tile_size;
#line 230 "../src/taquin-view.vala"
							_tmp85_ = taquin_view_get_game (self);
#line 230 "../src/taquin-view.vala"
							_tmp86_ = _tmp85_;
#line 230 "../src/taquin-view.vala"
							_tmp87_ = taquin_view_get_game (self);
#line 230 "../src/taquin-view.vala"
							_tmp88_ = _tmp87_;
#line 230 "../src/taquin-view.vala"
							_tmp89_ = game_get_size (_tmp88_);
#line 230 "../src/taquin-view.vala"
							_tmp90_ = _tmp89_;
#line 230 "../src/taquin-view.vala"
							texture_y = (game_get_tile_value (_tmp86_, (gint8) x, (gint8) y) / _tmp90_) * self->priv->tile_size;
#line 232 "../src/taquin-view.vala"
							cairo_matrix_init_identity (&matrix);
#line 233 "../src/taquin-view.vala"
							cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 234 "../src/taquin-view.vala"
							_tmp91_ = self->priv->tiles_pattern;
#line 234 "../src/taquin-view.vala"
							_tmp92_ = matrix;
#line 234 "../src/taquin-view.vala"
							cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp91_, &_tmp92_);
#line 235 "../src/taquin-view.vala"
							_tmp93_ = self->priv->tiles_pattern;
#line 235 "../src/taquin-view.vala"
							cairo_set_source (cr, (cairo_pattern_t*) _tmp93_);
#line 236 "../src/taquin-view.vala"
							cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 237 "../src/taquin-view.vala"
							cairo_fill (cr);
#line 1075 "taquin-view.c"
						}
					}
				}
			}
		}
	}
#line 241 "../src/taquin-view.vala"
	if (self->priv->animate_end) {
#line 1084 "taquin-view.c"
		cairo_matrix_t matrix = {0};
		cairo_pattern_t* _tmp94_;
		cairo_matrix_t _tmp95_;
#line 243 "../src/taquin-view.vala"
		self->priv->animation_end_offset = self->priv->animation_end_offset + 0.01;
#line 244 "../src/taquin-view.vala"
		if (self->priv->animation_end_offset >= ((gdouble) 1)) {
#line 245 "../src/taquin-view.vala"
			self->priv->animation_end_offset = (gdouble) 1;
#line 1094 "taquin-view.c"
		}
#line 246 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 247 "../src/taquin-view.vala"
		_tmp94_ = self->priv->tiles_pattern;
#line 247 "../src/taquin-view.vala"
		_tmp95_ = matrix;
#line 247 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp94_, &_tmp95_);
#line 248 "../src/taquin-view.vala"
		cairo_paint_with_alpha (cr, self->priv->animation_end_offset);
#line 249 "../src/taquin-view.vala"
		if (self->priv->animation_end_offset != ((gdouble) 1)) {
#line 250 "../src/taquin-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1110 "taquin-view.c"
		}
	}
#line 252 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 254 "../src/taquin-view.vala"
	if (self->priv->animate) {
#line 256 "../src/taquin-view.vala"
		self->priv->animation_offset = self->priv->animation_offset + 8;
#line 257 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 1121 "taquin-view.c"
			gint _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
			gint _tmp99_;
#line 258 "../src/taquin-view.vala"
			_tmp96_ = taquin_view_get_x_offset (self);
#line 258 "../src/taquin-view.vala"
			_tmp97_ = _tmp96_;
#line 258 "../src/taquin-view.vala"
			_tmp98_ = taquin_view_get_y_offset (self);
#line 258 "../src/taquin-view.vala"
			_tmp99_ = _tmp98_;
#line 258 "../src/taquin-view.vala"
			gtk_widget_queue_draw_area ((GtkWidget*) self, (_tmp97_ + self->priv->grid_border_main) + (self->priv->tile_size * MIN ((gint) self->priv->x_gap, self->priv->x_gap + self->priv->number)), (_tmp99_ + self->priv->grid_border_main) + (self->priv->tile_size * self->priv->y_gap), self->priv->tile_size * (abs (self->priv->number) + 1), self->priv->tile_size);
#line 1136 "taquin-view.c"
		} else {
			gint _tmp100_;
			gint _tmp101_;
			gint _tmp102_;
			gint _tmp103_;
#line 263 "../src/taquin-view.vala"
			_tmp100_ = taquin_view_get_x_offset (self);
#line 263 "../src/taquin-view.vala"
			_tmp101_ = _tmp100_;
#line 263 "../src/taquin-view.vala"
			_tmp102_ = taquin_view_get_y_offset (self);
#line 263 "../src/taquin-view.vala"
			_tmp103_ = _tmp102_;
#line 263 "../src/taquin-view.vala"
			gtk_widget_queue_draw_area ((GtkWidget*) self, (_tmp101_ + self->priv->grid_border_main) + (self->priv->tile_size * self->priv->x_gap), (_tmp103_ + self->priv->grid_border_main) + (self->priv->tile_size * MIN ((gint) self->priv->y_gap, self->priv->y_gap + self->priv->number)), self->priv->tile_size, self->priv->tile_size * (abs (self->priv->number) + 1));
#line 1152 "taquin-view.c"
		}
#line 267 "../src/taquin-view.vala"
		if (self->priv->animation_offset > self->priv->tile_size) {
#line 268 "../src/taquin-view.vala"
			self->priv->animate = FALSE;
#line 1158 "taquin-view.c"
		}
	}
#line 271 "../src/taquin-view.vala"
	result = FALSE;
#line 271 "../src/taquin-view.vala"
	return result;
#line 1165 "taquin-view.c"
}

static inline void
_taquin_view_refresh_pixmaps (cairo_t* context,
                              GdkPixbuf* unscaled_pixbuf,
                              gint* board_size)
{
	GdkPixbuf* tmp_pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 274 "../src/taquin-view.vala"
	g_return_if_fail (context != NULL);
#line 276 "../src/taquin-view.vala"
	if (unscaled_pixbuf == NULL) {
#line 277 "../src/taquin-view.vala"
		return;
#line 1183 "taquin-view.c"
	}
#line 281 "../src/taquin-view.vala"
	_tmp0_ = gdk_pixbuf_scale_simple (G_TYPE_CHECK_INSTANCE_CAST (unscaled_pixbuf, gdk_pixbuf_get_type (), GdkPixbuf), *board_size, *board_size, GDK_INTERP_BILINEAR);
#line 281 "../src/taquin-view.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 281 "../src/taquin-view.vala"
	tmp_pixbuf = _tmp0_;
#line 282 "../src/taquin-view.vala"
	_tmp1_ = tmp_pixbuf;
#line 282 "../src/taquin-view.vala"
	if (_tmp1_ == NULL) {
#line 283 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 1197 "taquin-view.c"
	}
#line 285 "../src/taquin-view.vala"
	_tmp2_ = tmp_pixbuf;
#line 285 "../src/taquin-view.vala"
	gdk_cairo_set_source_pixbuf (context, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gdk_pixbuf_get_type (), GdkPixbuf), (gdouble) 0, (gdouble) 0);
#line 286 "../src/taquin-view.vala"
	cairo_paint (context);
#line 274 "../src/taquin-view.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 1207 "taquin-view.c"
}

static inline void
_taquin_view_draw_board (cairo_t* cr,
                         gint* grid_border_main,
                         gint* board_size,
                         gint* grid_border_thin)
{
	gdouble half_grid_border_main_first_side = 0.0;
	gdouble board_size_plus_two_half_borders = 0.0;
	gdouble half_grid_border_main_other_side = 0.0;
	gdouble half_grid_borders_diff = 0.0;
#line 291 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 296 "../src/taquin-view.vala"
	half_grid_border_main_first_side = (*grid_border_main) / 2.0;
#line 297 "../src/taquin-view.vala"
	board_size_plus_two_half_borders = (gdouble) ((*board_size) + (*grid_border_main));
#line 298 "../src/taquin-view.vala"
	half_grid_border_main_other_side = board_size_plus_two_half_borders + half_grid_border_main_first_side;
#line 299 "../src/taquin-view.vala"
	half_grid_borders_diff = ((*grid_border_main) - (*grid_border_thin)) / 2.0;
#line 302 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.8, 0.8, 0.8);
#line 303 "../src/taquin-view.vala"
	cairo_rectangle (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, board_size_plus_two_half_borders, board_size_plus_two_half_borders);
#line 305 "../src/taquin-view.vala"
	cairo_fill_preserve (cr);
#line 306 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.3, 0.3, 0.3);
#line 307 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) (*grid_border_main));
#line 308 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 311 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.1, 0.1, 0.1);
#line 312 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) (*grid_border_thin));
#line 313 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, half_grid_borders_diff, G_PI, TAQUIN_VIEW_three_half_pi);
#line 314 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_other_side, half_grid_border_main_first_side, half_grid_borders_diff, TAQUIN_VIEW_three_half_pi, 0.0);
#line 315 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_other_side, half_grid_border_main_other_side, half_grid_borders_diff, 0.0, TAQUIN_VIEW_half_pi);
#line 316 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_other_side, half_grid_borders_diff, TAQUIN_VIEW_half_pi, G_PI);
#line 317 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, half_grid_borders_diff, G_PI, TAQUIN_VIEW_three_half_pi);
#line 318 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 1258 "taquin-view.c"
}

static inline void
taquin_view_draw_movable_lights (TaquinView* self,
                                 cairo_t* cr)
{
#line 321 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 323 "../src/taquin-view.vala"
	_taquin_view_draw_movable_lights (cr, &self->priv->animation_end_offset, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->x_arrow, &self->priv->grid_border_thin, &self->priv->board_size, &self->priv->y_arrow);
#line 1271 "taquin-view.c"
}

static inline void
_taquin_view_draw_movable_lights (cairo_t* cr,
                                  gdouble* animation_end_offset,
                                  gint* grid_border_main,
                                  gint* tile_size,
                                  gint8* x_arrow,
                                  gint* grid_border_thin,
                                  gint* board_size,
                                  gint8* y_arrow)
{
	gdouble half_grid_borders_sum = 0.0;
	gint board_size_plus_borders_diff = 0;
#line 325 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 334 "../src/taquin-view.vala"
	half_grid_borders_sum = ((*grid_border_main) + (*grid_border_thin)) / 2.0;
#line 335 "../src/taquin-view.vala"
	board_size_plus_borders_diff = ((*board_size) + (*grid_border_main)) - (*grid_border_thin);
#line 337 "../src/taquin-view.vala"
	cairo_save (cr);
#line 338 "../src/taquin-view.vala"
	cairo_set_source_rgba (cr, 0.7, 0.7, 0.7, 0.3 - (0.3 * (*animation_end_offset)));
#line 340 "../src/taquin-view.vala"
	cairo_save (cr);
#line 341 "../src/taquin-view.vala"
	cairo_translate (cr, (*grid_border_main) + ((*tile_size) * ((*x_arrow) + 0.5)), half_grid_borders_sum);
#line 342 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, TRUE, tile_size, grid_border_main);
#line 343 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) 0, (gdouble) board_size_plus_borders_diff);
#line 344 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, TRUE, tile_size, grid_border_main);
#line 345 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 346 "../src/taquin-view.vala"
	cairo_fill (cr);
#line 348 "../src/taquin-view.vala"
	cairo_save (cr);
#line 349 "../src/taquin-view.vala"
	cairo_translate (cr, half_grid_borders_sum, (*grid_border_main) + ((*tile_size) * ((*y_arrow) + 0.5)));
#line 350 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, FALSE, tile_size, grid_border_main);
#line 351 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) board_size_plus_borders_diff, (gdouble) 0);
#line 352 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, FALSE, tile_size, grid_border_main);
#line 353 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 354 "../src/taquin-view.vala"
	cairo_fill (cr);
#line 355 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 1326 "taquin-view.c"
}

static void
taquin_view_draw_light (cairo_t* cr,
                        gboolean horizontal,
                        gint* tile_size,
                        gint* grid_border_main)
{
	gdouble size = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 357 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 359 "../src/taquin-view.vala"
	cairo_save (cr);
#line 360 "../src/taquin-view.vala"
	size = (0.3 * (*tile_size)) / (*grid_border_main);
#line 361 "../src/taquin-view.vala"
	if (horizontal) {
#line 361 "../src/taquin-view.vala"
		_tmp0_ = size;
#line 1348 "taquin-view.c"
	} else {
#line 361 "../src/taquin-view.vala"
		_tmp0_ = 0.3;
#line 1352 "taquin-view.c"
	}
#line 361 "../src/taquin-view.vala"
	if (horizontal) {
#line 361 "../src/taquin-view.vala"
		_tmp1_ = 0.3;
#line 1358 "taquin-view.c"
	} else {
#line 361 "../src/taquin-view.vala"
		_tmp1_ = size;
#line 1362 "taquin-view.c"
	}
#line 361 "../src/taquin-view.vala"
	cairo_scale (cr, _tmp0_, _tmp1_);
#line 362 "../src/taquin-view.vala"
	cairo_arc (cr, 0.0, 0.0, (gdouble) (*grid_border_main), 0.0, 2.0 * G_PI);
#line 363 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 1370 "taquin-view.c"
}

static inline void
taquin_view_draw_fixed_arrows (TaquinView* self,
                               cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gint8 _tmp2_;
	gint8 _tmp3_;
#line 366 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 368 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 368 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 368 "../src/taquin-view.vala"
	_tmp2_ = game_get_size (_tmp1_);
#line 368 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 368 "../src/taquin-view.vala"
	_taquin_view_draw_fixed_arrows (cr, (gint) _tmp3_, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->grid_border_thin, &self->priv->board_size);
#line 1395 "taquin-view.c"
}

static inline void
_taquin_view_draw_fixed_arrows (cairo_t* cr,
                                gint game_size,
                                gint* grid_border_main,
                                gint* tile_size,
                                gint* grid_border_thin,
                                gint* board_size)
{
#line 370 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 1408 "taquin-view.c"
	{
		gint i = 0;
#line 376 "../src/taquin-view.vala"
		i = 0;
#line 1413 "taquin-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 376 "../src/taquin-view.vala"
			_tmp0_ = TRUE;
#line 376 "../src/taquin-view.vala"
			while (TRUE) {
#line 376 "../src/taquin-view.vala"
				if (!_tmp0_) {
#line 1422 "taquin-view.c"
					gint _tmp1_;
#line 376 "../src/taquin-view.vala"
					_tmp1_ = i;
#line 376 "../src/taquin-view.vala"
					i = _tmp1_ + 1;
#line 1428 "taquin-view.c"
				}
#line 376 "../src/taquin-view.vala"
				_tmp0_ = FALSE;
#line 376 "../src/taquin-view.vala"
				if (!(i < game_size)) {
#line 376 "../src/taquin-view.vala"
					break;
#line 1436 "taquin-view.c"
				}
#line 378 "../src/taquin-view.vala"
				taquin_view_draw_vertical_arrow (cr, FALSE, i, grid_border_main, tile_size, grid_border_thin, board_size);
#line 379 "../src/taquin-view.vala"
				taquin_view_draw_horizontal_arrow (cr, FALSE, i, grid_border_main, tile_size, grid_border_thin, board_size);
#line 1442 "taquin-view.c"
			}
		}
	}
}

static inline void
taquin_view_draw_movable_arrows (TaquinView* self,
                                 cairo_t* cr)
{
#line 383 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 385 "../src/taquin-view.vala"
	_taquin_view_draw_movable_arrows (cr, &self->priv->x_arrow, &self->priv->y_arrow, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->grid_border_thin, &self->priv->board_size);
#line 1458 "taquin-view.c"
}

static inline void
_taquin_view_draw_movable_arrows (cairo_t* cr,
                                  gint8* x_arrow,
                                  gint8* y_arrow,
                                  gint* grid_border_main,
                                  gint* tile_size,
                                  gint* grid_border_thin,
                                  gint* board_size)
{
#line 387 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 395 "../src/taquin-view.vala"
	taquin_view_draw_vertical_arrow (cr, TRUE, (gint) (*x_arrow), grid_border_main, tile_size, grid_border_thin, board_size);
#line 396 "../src/taquin-view.vala"
	taquin_view_draw_horizontal_arrow (cr, TRUE, (gint) (*y_arrow), grid_border_main, tile_size, grid_border_thin, board_size);
#line 1476 "taquin-view.c"
}

static void
taquin_view_draw_horizontal_arrow (cairo_t* cr,
                                   gboolean inside,
                                   gint number,
                                   gint* grid_border_main,
                                   gint* tile_size,
                                   gint* grid_border_thin,
                                   gint* board_size)
{
	gdouble x1 = 0.0;
	gdouble x2 = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 399 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 405 "../src/taquin-view.vala"
	x1 = (((*grid_border_main) * 1.0) / 3) + (((*grid_border_thin) * 2.0) / 3);
#line 406 "../src/taquin-view.vala"
	x2 = (((*grid_border_main) * 2.0) / 3) + (((*grid_border_thin) * 1.0) / 3);
#line 407 "../src/taquin-view.vala"
	if (inside) {
#line 407 "../src/taquin-view.vala"
		_tmp0_ = x1;
#line 1506 "taquin-view.c"
	} else {
#line 407 "../src/taquin-view.vala"
		_tmp0_ = x2;
#line 1510 "taquin-view.c"
	}
#line 407 "../src/taquin-view.vala"
	cairo_move_to (cr, _tmp0_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))));
#line 408 "../src/taquin-view.vala"
	if (inside) {
#line 408 "../src/taquin-view.vala"
		_tmp1_ = x2;
#line 1518 "taquin-view.c"
	} else {
#line 408 "../src/taquin-view.vala"
		_tmp1_ = x1;
#line 1522 "taquin-view.c"
	}
#line 408 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp1_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))));
#line 409 "../src/taquin-view.vala"
	if (inside) {
#line 409 "../src/taquin-view.vala"
		_tmp2_ = x1;
#line 1530 "taquin-view.c"
	} else {
#line 409 "../src/taquin-view.vala"
		_tmp2_ = x2;
#line 1534 "taquin-view.c"
	}
#line 409 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp2_, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))));
#line 410 "../src/taquin-view.vala"
	x1 = ((*board_size) + (((*grid_border_main) * 5.0) / 3)) - (((*grid_border_thin) * 2.0) / 3);
#line 411 "../src/taquin-view.vala"
	x2 = ((*board_size) + (((*grid_border_main) * 4.0) / 3)) - (((*grid_border_thin) * 1.0) / 3);
#line 412 "../src/taquin-view.vala"
	if (inside) {
#line 412 "../src/taquin-view.vala"
		_tmp3_ = x1;
#line 1546 "taquin-view.c"
	} else {
#line 412 "../src/taquin-view.vala"
		_tmp3_ = x2;
#line 1550 "taquin-view.c"
	}
#line 412 "../src/taquin-view.vala"
	cairo_move_to (cr, _tmp3_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))));
#line 413 "../src/taquin-view.vala"
	if (inside) {
#line 413 "../src/taquin-view.vala"
		_tmp4_ = x2;
#line 1558 "taquin-view.c"
	} else {
#line 413 "../src/taquin-view.vala"
		_tmp4_ = x1;
#line 1562 "taquin-view.c"
	}
#line 413 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp4_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))));
#line 414 "../src/taquin-view.vala"
	if (inside) {
#line 414 "../src/taquin-view.vala"
		_tmp5_ = x1;
#line 1570 "taquin-view.c"
	} else {
#line 414 "../src/taquin-view.vala"
		_tmp5_ = x2;
#line 1574 "taquin-view.c"
	}
#line 414 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp5_, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))));
#line 1578 "taquin-view.c"
}

static void
taquin_view_draw_vertical_arrow (cairo_t* cr,
                                 gboolean inside,
                                 gint number,
                                 gint* grid_border_main,
                                 gint* tile_size,
                                 gint* grid_border_thin,
                                 gint* board_size)
{
	gdouble y1 = 0.0;
	gdouble y2 = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 417 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 423 "../src/taquin-view.vala"
	y1 = (((*grid_border_main) * 1.0) / 3) + (((*grid_border_thin) * 2.0) / 3);
#line 424 "../src/taquin-view.vala"
	y2 = (((*grid_border_main) * 2.0) / 3) + (((*grid_border_thin) * 1.0) / 3);
#line 425 "../src/taquin-view.vala"
	if (inside) {
#line 425 "../src/taquin-view.vala"
		_tmp0_ = y1;
#line 1608 "taquin-view.c"
	} else {
#line 425 "../src/taquin-view.vala"
		_tmp0_ = y2;
#line 1612 "taquin-view.c"
	}
#line 425 "../src/taquin-view.vala"
	cairo_move_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))), _tmp0_);
#line 426 "../src/taquin-view.vala"
	if (inside) {
#line 426 "../src/taquin-view.vala"
		_tmp1_ = y2;
#line 1620 "taquin-view.c"
	} else {
#line 426 "../src/taquin-view.vala"
		_tmp1_ = y1;
#line 1624 "taquin-view.c"
	}
#line 426 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))), _tmp1_);
#line 427 "../src/taquin-view.vala"
	if (inside) {
#line 427 "../src/taquin-view.vala"
		_tmp2_ = y1;
#line 1632 "taquin-view.c"
	} else {
#line 427 "../src/taquin-view.vala"
		_tmp2_ = y2;
#line 1636 "taquin-view.c"
	}
#line 427 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))), _tmp2_);
#line 428 "../src/taquin-view.vala"
	y1 = ((*board_size) + (((*grid_border_main) * 5.0) / 3)) - (((*grid_border_thin) * 2.0) / 3);
#line 429 "../src/taquin-view.vala"
	y2 = ((*board_size) + (((*grid_border_main) * 4.0) / 3)) - (((*grid_border_thin) * 1.0) / 3);
#line 430 "../src/taquin-view.vala"
	if (inside) {
#line 430 "../src/taquin-view.vala"
		_tmp3_ = y1;
#line 1648 "taquin-view.c"
	} else {
#line 430 "../src/taquin-view.vala"
		_tmp3_ = y2;
#line 1652 "taquin-view.c"
	}
#line 430 "../src/taquin-view.vala"
	cairo_move_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))), _tmp3_);
#line 431 "../src/taquin-view.vala"
	if (inside) {
#line 431 "../src/taquin-view.vala"
		_tmp4_ = y2;
#line 1660 "taquin-view.c"
	} else {
#line 431 "../src/taquin-view.vala"
		_tmp4_ = y1;
#line 1664 "taquin-view.c"
	}
#line 431 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))), _tmp4_);
#line 432 "../src/taquin-view.vala"
	if (inside) {
#line 432 "../src/taquin-view.vala"
		_tmp5_ = y1;
#line 1672 "taquin-view.c"
	} else {
#line 432 "../src/taquin-view.vala"
		_tmp5_ = y2;
#line 1676 "taquin-view.c"
	}
#line 432 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))), _tmp5_);
#line 1680 "taquin-view.c"
}

static void
taquin_view_move_cb (TaquinView* self,
                     gboolean x_axis,
                     gint8 number,
                     gint8 x_gap,
                     gint8 y_gap,
                     guint moves_count,
                     gboolean disable_animation)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameType _tmp2_;
	GameType _tmp3_;
#line 435 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/taquin-view.vala"
	self->priv->x_axis = x_axis;
#line 438 "../src/taquin-view.vala"
	self->priv->number = (gint) number;
#line 439 "../src/taquin-view.vala"
	self->priv->x_gap = x_gap;
#line 440 "../src/taquin-view.vala"
	self->priv->y_gap = y_gap;
#line 442 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 442 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 442 "../src/taquin-view.vala"
	_tmp2_ = game_get_game_type (_tmp1_);
#line 442 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 442 "../src/taquin-view.vala"
	if (_tmp3_ == GAME_TYPE_FIFTEEN) {
#line 444 "../src/taquin-view.vala"
		self->priv->x_arrow = x_gap;
#line 445 "../src/taquin-view.vala"
		self->priv->y_arrow = y_gap;
#line 1720 "taquin-view.c"
	}
#line 447 "../src/taquin-view.vala"
	if (disable_animation) {
#line 449 "../src/taquin-view.vala"
		self->priv->finished = FALSE;
#line 450 "../src/taquin-view.vala"
		self->priv->animation_end_offset = (gdouble) 0;
#line 451 "../src/taquin-view.vala"
		self->priv->animate_end = FALSE;
#line 1730 "taquin-view.c"
	} else {
#line 455 "../src/taquin-view.vala"
		self->priv->animation_offset = 0;
#line 456 "../src/taquin-view.vala"
		self->priv->animate = TRUE;
#line 1736 "taquin-view.c"
	}
#line 458 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1740 "taquin-view.c"
}

static gboolean
__lambda13_ (TaquinView* self)
{
	gboolean result;
#line 466 "../src/taquin-view.vala"
	self->priv->animation_end_offset = (gdouble) 0;
#line 467 "../src/taquin-view.vala"
	self->priv->animate_end = TRUE;
#line 468 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 470 "../src/taquin-view.vala"
	result = FALSE;
#line 470 "../src/taquin-view.vala"
	return result;
#line 1757 "taquin-view.c"
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((TaquinView*) self);
#line 464 "../src/taquin-view.vala"
	return result;
#line 1767 "taquin-view.c"
}

static void
taquin_view_complete_cb (TaquinView* self)
{
#line 461 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/taquin-view.vala"
	self->priv->finished = TRUE;
#line 464 "../src/taquin-view.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
#line 1779 "taquin-view.c"
}

static void
_taquin_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                       gint n_press,
                                                       gdouble x,
                                                       gdouble y,
                                                       gpointer self)
{
#line 484 "../src/taquin-view.vala"
	taquin_view_on_click ((TaquinView*) self, _sender, n_press, x, y);
#line 1791 "taquin-view.c"
}

static void
taquin_view_init_mouse (TaquinView* self)
{
	GtkGestureMultiPress* _tmp0_;
	GtkGestureMultiPress* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
#line 480 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/taquin-view.vala"
	_tmp0_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 482 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 482 "../src/taquin-view.vala"
	self->priv->click_controller = _tmp0_;
#line 483 "../src/taquin-view.vala"
	_tmp1_ = self->priv->click_controller;
#line 483 "../src/taquin-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp1_, (guint) 0);
#line 484 "../src/taquin-view.vala"
	_tmp2_ = self->priv->click_controller;
#line 484 "../src/taquin-view.vala"
	g_signal_connect_object (_tmp2_, "pressed", (GCallback) _taquin_view_on_click_gtk_gesture_multi_press_pressed, self, 0);
#line 1816 "taquin-view.c"
}

static inline void
taquin_view_on_click (TaquinView* self,
                      GtkGestureMultiPress* _click_controller,
                      gint n_press,
                      gdouble event_x,
                      gdouble event_y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint button = 0U;
	gboolean _tmp2_ = FALSE;
	Game* _tmp3_;
	Game* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 487 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/taquin-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 489 "../src/taquin-view.vala"
	if (self->priv->finished) {
#line 489 "../src/taquin-view.vala"
		_tmp1_ = TRUE;
#line 1844 "taquin-view.c"
	} else {
#line 489 "../src/taquin-view.vala"
		_tmp1_ = self->priv->animate;
#line 1848 "taquin-view.c"
	}
#line 489 "../src/taquin-view.vala"
	if (_tmp1_) {
#line 489 "../src/taquin-view.vala"
		_tmp0_ = TRUE;
#line 1854 "taquin-view.c"
	} else {
#line 489 "../src/taquin-view.vala"
		_tmp0_ = self->priv->animate_end;
#line 1858 "taquin-view.c"
	}
#line 489 "../src/taquin-view.vala"
	if (_tmp0_) {
#line 490 "../src/taquin-view.vala"
		return;
#line 1864 "taquin-view.c"
	}
#line 492 "../src/taquin-view.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _click_controller);
#line 493 "../src/taquin-view.vala"
	if (button != ((guint) GDK_BUTTON_PRIMARY)) {
#line 493 "../src/taquin-view.vala"
		_tmp2_ = button != ((guint) GDK_BUTTON_SECONDARY);
#line 1872 "taquin-view.c"
	} else {
#line 493 "../src/taquin-view.vala"
		_tmp2_ = FALSE;
#line 1876 "taquin-view.c"
	}
#line 493 "../src/taquin-view.vala"
	if (_tmp2_) {
#line 494 "../src/taquin-view.vala"
		return;
#line 1882 "taquin-view.c"
	}
#line 496 "../src/taquin-view.vala"
	self->priv->draw_lights = FALSE;
#line 497 "../src/taquin-view.vala"
	_tmp3_ = taquin_view_get_game (self);
#line 497 "../src/taquin-view.vala"
	_tmp4_ = _tmp3_;
#line 497 "../src/taquin-view.vala"
	_tmp5_ = taquin_view_get_x_offset (self);
#line 497 "../src/taquin-view.vala"
	_tmp6_ = _tmp5_;
#line 497 "../src/taquin-view.vala"
	_tmp7_ = taquin_view_get_y_offset (self);
#line 497 "../src/taquin-view.vala"
	_tmp8_ = _tmp7_;
#line 497 "../src/taquin-view.vala"
	game_request_move (_tmp4_, (gint8) ((((gint) (((event_x - _tmp6_) - self->priv->grid_border_main) + self->priv->tile_size)) / self->priv->tile_size) - 1), (gint8) ((((gint) (((event_y - _tmp8_) - self->priv->grid_border_main) + self->priv->tile_size)) / self->priv->tile_size) - 1), FALSE);
#line 1900 "taquin-view.c"
}

static gboolean
_taquin_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = taquin_view_on_key_pressed ((TaquinView*) self, _sender, keyval, keycode, state);
#line 511 "../src/taquin-view.vala"
	return result;
#line 1914 "taquin-view.c"
}

static void
taquin_view_init_keyboard (TaquinView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
#line 508 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 510 "../src/taquin-view.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 510 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 510 "../src/taquin-view.vala"
	self->priv->key_controller = _tmp0_;
#line 511 "../src/taquin-view.vala"
	_tmp1_ = self->priv->key_controller;
#line 511 "../src/taquin-view.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _taquin_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 1934 "taquin-view.c"
}

static inline gboolean
taquin_view_on_key_pressed (TaquinView* self,
                            GtkEventControllerKey* _key_controller,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* k_name = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Game* _tmp4_;
	Game* _tmp5_;
	GameType _tmp6_;
	GameType _tmp7_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	const gchar* _tmp31_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	GQuark _tmp39_ = 0U;
#line 535 "../src/taquin-view.vala"
	static GQuark _tmp38_label0 = 0;
#line 535 "../src/taquin-view.vala"
	static GQuark _tmp38_label1 = 0;
#line 535 "../src/taquin-view.vala"
	static GQuark _tmp38_label2 = 0;
#line 535 "../src/taquin-view.vala"
	static GQuark _tmp38_label3 = 0;
#line 1967 "taquin-view.c"
	gboolean result;
#line 514 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 514 "../src/taquin-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 516 "../src/taquin-view.vala"
	if (self->priv->finished) {
#line 517 "../src/taquin-view.vala"
		result = FALSE;
#line 517 "../src/taquin-view.vala"
		return result;
#line 1979 "taquin-view.c"
	}
#line 518 "../src/taquin-view.vala"
	_tmp1_ = gdk_keyval_name (keyval);
#line 518 "../src/taquin-view.vala"
	_tmp0_ = _tmp1_;
#line 518 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 518 "../src/taquin-view.vala"
		_tmp0_ = "";
#line 1989 "taquin-view.c"
	}
#line 518 "../src/taquin-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 518 "../src/taquin-view.vala"
	k_name = _tmp2_;
#line 520 "../src/taquin-view.vala"
	_tmp4_ = taquin_view_get_game (self);
#line 520 "../src/taquin-view.vala"
	_tmp5_ = _tmp4_;
#line 520 "../src/taquin-view.vala"
	_tmp6_ = game_get_game_type (_tmp5_);
#line 520 "../src/taquin-view.vala"
	_tmp7_ = _tmp6_;
#line 520 "../src/taquin-view.vala"
	if (_tmp7_ == GAME_TYPE_SIXTEEN) {
#line 2005 "taquin-view.c"
		gboolean _tmp8_ = FALSE;
#line 520 "../src/taquin-view.vala"
		if ((state & GDK_SHIFT_MASK) > 0) {
#line 520 "../src/taquin-view.vala"
			_tmp8_ = TRUE;
#line 2011 "taquin-view.c"
		} else {
#line 520 "../src/taquin-view.vala"
			_tmp8_ = (state & GDK_CONTROL_MASK) > 0;
#line 2015 "taquin-view.c"
		}
#line 520 "../src/taquin-view.vala"
		_tmp3_ = _tmp8_;
#line 2019 "taquin-view.c"
	} else {
#line 520 "../src/taquin-view.vala"
		_tmp3_ = FALSE;
#line 2023 "taquin-view.c"
	}
#line 520 "../src/taquin-view.vala"
	if (_tmp3_) {
#line 2027 "taquin-view.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GQuark _tmp12_ = 0U;
#line 522 "../src/taquin-view.vala"
		static GQuark _tmp11_label0 = 0;
#line 522 "../src/taquin-view.vala"
		static GQuark _tmp11_label1 = 0;
#line 522 "../src/taquin-view.vala"
		static GQuark _tmp11_label2 = 0;
#line 522 "../src/taquin-view.vala"
		static GQuark _tmp11_label3 = 0;
#line 522 "../src/taquin-view.vala"
		_tmp9_ = k_name;
#line 522 "../src/taquin-view.vala"
		_tmp10_ = _tmp9_;
#line 522 "../src/taquin-view.vala"
		_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
#line 522 "../src/taquin-view.vala"
		if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("Left")))) {
#line 522 "../src/taquin-view.vala"
			switch (0) {
#line 2049 "taquin-view.c"
				default:
				{
					Game* _tmp13_;
					Game* _tmp14_;
#line 523 "../src/taquin-view.vala"
					_tmp13_ = taquin_view_get_game (self);
#line 523 "../src/taquin-view.vala"
					_tmp14_ = _tmp13_;
#line 523 "../src/taquin-view.vala"
					game_request_move (_tmp14_, (gint8) -1, self->priv->y_arrow, TRUE);
#line 523 "../src/taquin-view.vala"
					break;
#line 2062 "taquin-view.c"
				}
			}
		} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("Right")))) {
#line 522 "../src/taquin-view.vala"
			switch (0) {
#line 2068 "taquin-view.c"
				default:
				{
					Game* _tmp15_;
					Game* _tmp16_;
					Game* _tmp17_;
					Game* _tmp18_;
					gint8 _tmp19_;
					gint8 _tmp20_;
#line 524 "../src/taquin-view.vala"
					_tmp15_ = taquin_view_get_game (self);
#line 524 "../src/taquin-view.vala"
					_tmp16_ = _tmp15_;
#line 524 "../src/taquin-view.vala"
					_tmp17_ = taquin_view_get_game (self);
#line 524 "../src/taquin-view.vala"
					_tmp18_ = _tmp17_;
#line 524 "../src/taquin-view.vala"
					_tmp19_ = game_get_size (_tmp18_);
#line 524 "../src/taquin-view.vala"
					_tmp20_ = _tmp19_;
#line 524 "../src/taquin-view.vala"
					game_request_move (_tmp16_, _tmp20_, self->priv->y_arrow, TRUE);
#line 524 "../src/taquin-view.vala"
					break;
#line 2093 "taquin-view.c"
				}
			}
		} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("Up")))) {
#line 522 "../src/taquin-view.vala"
			switch (0) {
#line 2099 "taquin-view.c"
				default:
				{
					Game* _tmp21_;
					Game* _tmp22_;
#line 525 "../src/taquin-view.vala"
					_tmp21_ = taquin_view_get_game (self);
#line 525 "../src/taquin-view.vala"
					_tmp22_ = _tmp21_;
#line 525 "../src/taquin-view.vala"
					game_request_move (_tmp22_, self->priv->x_arrow, (gint8) -1, TRUE);
#line 525 "../src/taquin-view.vala"
					break;
#line 2112 "taquin-view.c"
				}
			}
		} else if (_tmp12_ == ((0 != _tmp11_label3) ? _tmp11_label3 : (_tmp11_label3 = g_quark_from_static_string ("Down")))) {
#line 522 "../src/taquin-view.vala"
			switch (0) {
#line 2118 "taquin-view.c"
				default:
				{
					Game* _tmp23_;
					Game* _tmp24_;
					Game* _tmp25_;
					Game* _tmp26_;
					gint8 _tmp27_;
					gint8 _tmp28_;
#line 526 "../src/taquin-view.vala"
					_tmp23_ = taquin_view_get_game (self);
#line 526 "../src/taquin-view.vala"
					_tmp24_ = _tmp23_;
#line 526 "../src/taquin-view.vala"
					_tmp25_ = taquin_view_get_game (self);
#line 526 "../src/taquin-view.vala"
					_tmp26_ = _tmp25_;
#line 526 "../src/taquin-view.vala"
					_tmp27_ = game_get_size (_tmp26_);
#line 526 "../src/taquin-view.vala"
					_tmp28_ = _tmp27_;
#line 526 "../src/taquin-view.vala"
					game_request_move (_tmp24_, self->priv->x_arrow, _tmp28_, TRUE);
#line 526 "../src/taquin-view.vala"
					break;
#line 2143 "taquin-view.c"
				}
			}
		} else {
#line 522 "../src/taquin-view.vala"
			switch (0) {
#line 2149 "taquin-view.c"
				default:
				{
#line 527 "../src/taquin-view.vala"
					result = FALSE;
#line 527 "../src/taquin-view.vala"
					_g_free0 (k_name);
#line 527 "../src/taquin-view.vala"
					return result;
#line 2158 "taquin-view.c"
				}
			}
		}
	}
#line 530 "../src/taquin-view.vala"
	_tmp31_ = k_name;
#line 530 "../src/taquin-view.vala"
	if (g_strcmp0 (_tmp31_, "space") == 0) {
#line 530 "../src/taquin-view.vala"
		_tmp30_ = TRUE;
#line 2169 "taquin-view.c"
	} else {
		const gchar* _tmp32_;
#line 530 "../src/taquin-view.vala"
		_tmp32_ = k_name;
#line 530 "../src/taquin-view.vala"
		_tmp30_ = g_strcmp0 (_tmp32_, "KP_Enter") == 0;
#line 2176 "taquin-view.c"
	}
#line 530 "../src/taquin-view.vala"
	if (_tmp30_) {
#line 530 "../src/taquin-view.vala"
		_tmp29_ = TRUE;
#line 2182 "taquin-view.c"
	} else {
		const gchar* _tmp33_;
#line 530 "../src/taquin-view.vala"
		_tmp33_ = k_name;
#line 530 "../src/taquin-view.vala"
		_tmp29_ = g_strcmp0 (_tmp33_, "Return") == 0;
#line 2189 "taquin-view.c"
	}
#line 530 "../src/taquin-view.vala"
	if (_tmp29_) {
#line 2193 "taquin-view.c"
		Game* _tmp34_;
		Game* _tmp35_;
#line 532 "../src/taquin-view.vala"
		_tmp34_ = taquin_view_get_game (self);
#line 532 "../src/taquin-view.vala"
		_tmp35_ = _tmp34_;
#line 532 "../src/taquin-view.vala"
		game_request_move (_tmp35_, self->priv->x_arrow, self->priv->y_arrow, TRUE);
#line 533 "../src/taquin-view.vala"
		result = TRUE;
#line 533 "../src/taquin-view.vala"
		_g_free0 (k_name);
#line 533 "../src/taquin-view.vala"
		return result;
#line 2208 "taquin-view.c"
	}
#line 535 "../src/taquin-view.vala"
	_tmp36_ = k_name;
#line 535 "../src/taquin-view.vala"
	_tmp37_ = _tmp36_;
#line 535 "../src/taquin-view.vala"
	_tmp39_ = (NULL == _tmp37_) ? 0 : g_quark_from_string (_tmp37_);
#line 535 "../src/taquin-view.vala"
	if (_tmp39_ == ((0 != _tmp38_label0) ? _tmp38_label0 : (_tmp38_label0 = g_quark_from_static_string ("Left")))) {
#line 535 "../src/taquin-view.vala"
		switch (0) {
#line 2220 "taquin-view.c"
			default:
			{
#line 536 "../src/taquin-view.vala"
				if (((gint) self->priv->x_arrow) > 0) {
#line 2225 "taquin-view.c"
					gint8 _tmp40_;
#line 536 "../src/taquin-view.vala"
					_tmp40_ = self->priv->x_arrow;
#line 536 "../src/taquin-view.vala"
					self->priv->x_arrow = _tmp40_ - 1;
#line 2231 "taquin-view.c"
				}
#line 536 "../src/taquin-view.vala"
				break;
#line 2235 "taquin-view.c"
			}
		}
	} else if (_tmp39_ == ((0 != _tmp38_label1) ? _tmp38_label1 : (_tmp38_label1 = g_quark_from_static_string ("Right")))) {
#line 535 "../src/taquin-view.vala"
		switch (0) {
#line 2241 "taquin-view.c"
			default:
			{
				Game* _tmp41_;
				Game* _tmp42_;
				gint8 _tmp43_;
				gint8 _tmp44_;
#line 537 "../src/taquin-view.vala"
				_tmp41_ = taquin_view_get_game (self);
#line 537 "../src/taquin-view.vala"
				_tmp42_ = _tmp41_;
#line 537 "../src/taquin-view.vala"
				_tmp43_ = game_get_size (_tmp42_);
#line 537 "../src/taquin-view.vala"
				_tmp44_ = _tmp43_;
#line 537 "../src/taquin-view.vala"
				if (((gint) self->priv->x_arrow) < (_tmp44_ - 1)) {
#line 2258 "taquin-view.c"
					gint8 _tmp45_;
#line 537 "../src/taquin-view.vala"
					_tmp45_ = self->priv->x_arrow;
#line 537 "../src/taquin-view.vala"
					self->priv->x_arrow = _tmp45_ + 1;
#line 2264 "taquin-view.c"
				}
#line 537 "../src/taquin-view.vala"
				break;
#line 2268 "taquin-view.c"
			}
		}
	} else if (_tmp39_ == ((0 != _tmp38_label2) ? _tmp38_label2 : (_tmp38_label2 = g_quark_from_static_string ("Up")))) {
#line 535 "../src/taquin-view.vala"
		switch (0) {
#line 2274 "taquin-view.c"
			default:
			{
#line 538 "../src/taquin-view.vala"
				if (((gint) self->priv->y_arrow) > 0) {
#line 2279 "taquin-view.c"
					gint8 _tmp46_;
#line 538 "../src/taquin-view.vala"
					_tmp46_ = self->priv->y_arrow;
#line 538 "../src/taquin-view.vala"
					self->priv->y_arrow = _tmp46_ - 1;
#line 2285 "taquin-view.c"
				}
#line 538 "../src/taquin-view.vala"
				break;
#line 2289 "taquin-view.c"
			}
		}
	} else if (_tmp39_ == ((0 != _tmp38_label3) ? _tmp38_label3 : (_tmp38_label3 = g_quark_from_static_string ("Down")))) {
#line 535 "../src/taquin-view.vala"
		switch (0) {
#line 2295 "taquin-view.c"
			default:
			{
				Game* _tmp47_;
				Game* _tmp48_;
				gint8 _tmp49_;
				gint8 _tmp50_;
#line 539 "../src/taquin-view.vala"
				_tmp47_ = taquin_view_get_game (self);
#line 539 "../src/taquin-view.vala"
				_tmp48_ = _tmp47_;
#line 539 "../src/taquin-view.vala"
				_tmp49_ = game_get_size (_tmp48_);
#line 539 "../src/taquin-view.vala"
				_tmp50_ = _tmp49_;
#line 539 "../src/taquin-view.vala"
				if (((gint) self->priv->y_arrow) < (_tmp50_ - 1)) {
#line 2312 "taquin-view.c"
					gint8 _tmp51_;
#line 539 "../src/taquin-view.vala"
					_tmp51_ = self->priv->y_arrow;
#line 539 "../src/taquin-view.vala"
					self->priv->y_arrow = _tmp51_ + 1;
#line 2318 "taquin-view.c"
				}
#line 539 "../src/taquin-view.vala"
				break;
#line 2322 "taquin-view.c"
			}
		}
	} else {
#line 535 "../src/taquin-view.vala"
		switch (0) {
#line 2328 "taquin-view.c"
			default:
			{
#line 540 "../src/taquin-view.vala"
				result = FALSE;
#line 540 "../src/taquin-view.vala"
				_g_free0 (k_name);
#line 540 "../src/taquin-view.vala"
				return result;
#line 2337 "taquin-view.c"
			}
		}
	}
#line 542 "../src/taquin-view.vala"
	self->priv->draw_lights = TRUE;
#line 543 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 544 "../src/taquin-view.vala"
	result = TRUE;
#line 544 "../src/taquin-view.vala"
	_g_free0 (k_name);
#line 544 "../src/taquin-view.vala"
	return result;
#line 2351 "taquin-view.c"
}

static gint
taquin_view_get_x_offset (TaquinView* self)
{
	gint result;
#line 43 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/taquin-view.vala"
	result = ((gtk_widget_get_allocated_width ((GtkWidget*) self) - self->priv->board_size) / 2) - self->priv->grid_border_main;
#line 43 "../src/taquin-view.vala"
	return result;
#line 2364 "taquin-view.c"
}

static gint
taquin_view_get_y_offset (TaquinView* self)
{
	gint result;
#line 44 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/taquin-view.vala"
	result = ((gtk_widget_get_allocated_height ((GtkWidget*) self) - self->priv->board_size) / 2) - self->priv->grid_border_main;
#line 44 "../src/taquin-view.vala"
	return result;
#line 2377 "taquin-view.c"
}

static Game*
taquin_view_get_game (TaquinView* self)
{
	Game* result;
	Game* _tmp0_;
	Game* _tmp1_;
#line 81 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_game;
#line 81 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 81 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2394 "taquin-view.c"
	}
#line 81 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_game;
#line 81 "../src/taquin-view.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_GAME, Game);
#line 81 "../src/taquin-view.vala"
	return result;
#line 2402 "taquin-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/taquin-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 2410 "taquin-view.c"
}

static void
_taquin_view_move_cb_game_move (Game* _sender,
                                gboolean x_axis,
                                gint8 number,
                                gint8 x_gap,
                                gint8 y_gap,
                                guint moves_count,
                                gboolean disable_animation,
                                gpointer self)
{
#line 100 "../src/taquin-view.vala"
	taquin_view_move_cb ((TaquinView*) self, x_axis, number, x_gap, y_gap, moves_count, disable_animation);
#line 2425 "taquin-view.c"
}

static void
_taquin_view_complete_cb_game_complete (Game* _sender,
                                        gpointer self)
{
#line 101 "../src/taquin-view.vala"
	taquin_view_complete_cb ((TaquinView*) self);
#line 2434 "taquin-view.c"
}

void
taquin_view_set_game (TaquinView* self,
                      Game* value)
{
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
#line 82 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_game;
#line 84 "../src/taquin-view.vala"
	if (_tmp0_ != NULL) {
#line 2452 "taquin-view.c"
		Game* _tmp1_;
#line 85 "../src/taquin-view.vala"
		_tmp1_ = self->priv->_game;
#line 85 "../src/taquin-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 2458 "taquin-view.c"
	}
#line 87 "../src/taquin-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 87 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 87 "../src/taquin-view.vala"
	self->priv->_game = _tmp2_;
#line 88 "../src/taquin-view.vala"
	_tmp3_ = self->priv->_game;
#line 88 "../src/taquin-view.vala"
	if (_tmp3_ == NULL) {
#line 89 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2472 "taquin-view.c"
	}
#line 91 "../src/taquin-view.vala"
	self->priv->animate = FALSE;
#line 92 "../src/taquin-view.vala"
	self->priv->finished = FALSE;
#line 93 "../src/taquin-view.vala"
	self->priv->animate_end = FALSE;
#line 94 "../src/taquin-view.vala"
	self->priv->animation_end_offset = (gdouble) 0;
#line 95 "../src/taquin-view.vala"
	self->priv->draw_lights = FALSE;
#line 96 "../src/taquin-view.vala"
	self->priv->x_arrow = (gint8) 0;
#line 97 "../src/taquin-view.vala"
	self->priv->y_arrow = (gint8) 0;
#line 98 "../src/taquin-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 98 "../src/taquin-view.vala"
	self->priv->tiles_pattern = NULL;
#line 99 "../src/taquin-view.vala"
	taquin_view_configure (self);
#line 100 "../src/taquin-view.vala"
	_tmp4_ = self->priv->_game;
#line 100 "../src/taquin-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_GAME, Game), "move", (GCallback) _taquin_view_move_cb_game_move, self, 0);
#line 101 "../src/taquin-view.vala"
	_tmp5_ = self->priv->_game;
#line 101 "../src/taquin-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_GAME, Game), "complete", (GCallback) _taquin_view_complete_cb_game_complete, self, 0);
#line 102 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2504 "taquin-view.c"
}

static const gchar*
taquin_view_get_theme (TaquinView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 110 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_theme;
#line 110 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 110 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2521 "taquin-view.c"
	}
#line 110 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_theme;
#line 110 "../src/taquin-view.vala"
	result = (const gchar*) _tmp1_;
#line 110 "../src/taquin-view.vala"
	return result;
#line 2529 "taquin-view.c"
}

void
taquin_view_set_theme (TaquinView* self,
                       const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 111 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/taquin-view.vala"
	_tmp0_ = g_strdup (value);
#line 113 "../src/taquin-view.vala"
	_g_free0 (self->priv->_theme);
#line 113 "../src/taquin-view.vala"
	self->priv->_theme = _tmp0_;
#line 114 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_theme;
#line 114 "../src/taquin-view.vala"
	if (_tmp1_ == NULL) {
#line 115 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2553 "taquin-view.c"
	}
	{
		GdkPixbuf* _tmp2_ = NULL;
		const gchar* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 116 "../src/taquin-view.vala"
		_tmp3_ = self->priv->_theme;
#line 116 "../src/taquin-view.vala"
		_tmp4_ = gdk_pixbuf_new_from_file ((const gchar*) _tmp3_, &_inner_error0_);
#line 116 "../src/taquin-view.vala"
		_tmp2_ = _tmp4_;
#line 116 "../src/taquin-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2568 "taquin-view.c"
			goto __catch0_g_error;
		}
#line 116 "../src/taquin-view.vala"
		_tmp5_ = _tmp2_;
#line 116 "../src/taquin-view.vala"
		_tmp2_ = NULL;
#line 116 "../src/taquin-view.vala"
		_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 116 "../src/taquin-view.vala"
		self->priv->unscaled_pixbuf = _tmp5_;
#line 116 "../src/taquin-view.vala"
		_g_object_unref0 (_tmp2_);
#line 2581 "taquin-view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp6_;
#line 116 "../src/taquin-view.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../src/taquin-view.vala"
		_tmp6_ = self->priv->_theme;
#line 117 "../src/taquin-view.vala"
		g_critical ("taquin-view.vala:117: failed to load theme: %s", (const gchar*) _tmp6_);
#line 117 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2595 "taquin-view.c"
	}
	__finally0:
#line 116 "../src/taquin-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/taquin-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/taquin-view.vala"
		g_clear_error (&_inner_error0_);
#line 116 "../src/taquin-view.vala"
		return;
#line 2606 "taquin-view.c"
	}
#line 118 "../src/taquin-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 118 "../src/taquin-view.vala"
	self->priv->tiles_pattern = NULL;
#line 119 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2614 "taquin-view.c"
}

static GObject *
taquin_view_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TaquinView * self;
#line 66 "../src/taquin-view.vala"
	parent_class = G_OBJECT_CLASS (taquin_view_parent_class);
#line 66 "../src/taquin-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 66 "../src/taquin-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAQUIN_VIEW, TaquinView);
#line 68 "../src/taquin-view.vala"
	taquin_view_init_keyboard (self);
#line 69 "../src/taquin-view.vala"
	taquin_view_init_mouse (self);
#line 66 "../src/taquin-view.vala"
	return obj;
#line 2637 "taquin-view.c"
}

static void
taquin_view_class_init (TaquinViewClass * klass,
                        gpointer klass_data)
{
#line 32 "../src/taquin-view.vala"
	taquin_view_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/taquin-view.vala"
	g_type_class_adjust_private_offset (klass, &TaquinView_private_offset);
#line 32 "../src/taquin-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) taquin_view_real_configure_event;
#line 32 "../src/taquin-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) taquin_view_real_draw;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_taquin_view_get_property;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_taquin_view_set_property;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->constructor = taquin_view_constructor;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->finalize = taquin_view_finalize;
#line 32 "../src/taquin-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAQUIN_VIEW_GAME_PROPERTY, taquin_view_properties[TAQUIN_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 32 "../src/taquin-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAQUIN_VIEW_THEME_PROPERTY, taquin_view_properties[TAQUIN_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 2664 "taquin-view.c"
}

static void
taquin_view_instance_init (TaquinView * self,
                           gpointer klass)
{
#line 32 "../src/taquin-view.vala"
	self->priv = taquin_view_get_instance_private (self);
#line 37 "../src/taquin-view.vala"
	self->priv->grid_border_thin = 6;
#line 47 "../src/taquin-view.vala"
	self->priv->x_arrow = (gint8) 0;
#line 48 "../src/taquin-view.vala"
	self->priv->y_arrow = (gint8) 0;
#line 49 "../src/taquin-view.vala"
	self->priv->draw_lights = FALSE;
#line 52 "../src/taquin-view.vala"
	self->priv->render_size = 0;
#line 53 "../src/taquin-view.vala"
	self->priv->tiles_pattern = NULL;
#line 56 "../src/taquin-view.vala"
	self->priv->animate = FALSE;
#line 62 "../src/taquin-view.vala"
	self->priv->animate_end = FALSE;
#line 63 "../src/taquin-view.vala"
	self->priv->finished = FALSE;
#line 78 "../src/taquin-view.vala"
	self->priv->_game = NULL;
#line 106 "../src/taquin-view.vala"
	self->priv->unscaled_pixbuf = NULL;
#line 107 "../src/taquin-view.vala"
	self->priv->_theme = NULL;
#line 2697 "taquin-view.c"
}

static void
taquin_view_finalize (GObject * obj)
{
	TaquinView * self;
#line 32 "../src/taquin-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAQUIN_VIEW, TaquinView);
#line 53 "../src/taquin-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 78 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 106 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 107 "../src/taquin-view.vala"
	_g_free0 (self->priv->_theme);
#line 478 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 506 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (taquin_view_parent_class)->finalize (obj);
#line 2720 "taquin-view.c"
}

static GType
taquin_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TaquinViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) taquin_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TaquinView), 0, (GInstanceInitFunc) taquin_view_instance_init, NULL };
	GType taquin_view_type_id;
	taquin_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "TaquinView", &g_define_type_info, 0);
	TaquinView_private_offset = g_type_add_instance_private (taquin_view_type_id, sizeof (TaquinViewPrivate));
	return taquin_view_type_id;
}

GType
taquin_view_get_type (void)
{
	static volatile gsize taquin_view_type_id__once = 0;
	if (g_once_init_enter (&taquin_view_type_id__once)) {
		GType taquin_view_type_id;
		taquin_view_type_id = taquin_view_get_type_once ();
		g_once_init_leave (&taquin_view_type_id__once, taquin_view_type_id);
	}
	return taquin_view_type_id__once;
}

static void
_vala_taquin_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	TaquinView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAQUIN_VIEW, TaquinView);
#line 32 "../src/taquin-view.vala"
	switch (property_id) {
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_GAME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		g_value_set_object (value, taquin_view_get_game (self));
#line 32 "../src/taquin-view.vala"
		break;
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_THEME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		g_value_set_string (value, taquin_view_get_theme (self));
#line 32 "../src/taquin-view.vala"
		break;
#line 2767 "taquin-view.c"
		default:
#line 32 "../src/taquin-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/taquin-view.vala"
		break;
#line 2773 "taquin-view.c"
	}
}

static void
_vala_taquin_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	TaquinView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAQUIN_VIEW, TaquinView);
#line 32 "../src/taquin-view.vala"
	switch (property_id) {
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_GAME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		taquin_view_set_game (self, g_value_get_object (value));
#line 32 "../src/taquin-view.vala"
		break;
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_THEME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		taquin_view_set_theme (self, g_value_get_string (value));
#line 32 "../src/taquin-view.vala"
		break;
#line 2799 "taquin-view.c"
		default:
#line 32 "../src/taquin-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/taquin-view.vala"
		break;
#line 2805 "taquin-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

